diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.ui.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.ui.js
index ee6edcd1b..f57d540f0 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.ui.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.ui.js
@@ -19,7 +19,7 @@ export function getNodeColumnSchema(treeNodeInfo, itemNodeData, pgBrowser) {
 }
 
 export default class ColumnSchema extends BaseUISchema {
-  constructor(getPrivilegeRoleSchema, nodeInfo, cltypeOptions, collspcnameOptions) {
+  constructor(getPrivilegeRoleSchema, nodeInfo, cltypeOptions, collspcnameOptions, inErd=false) {
     super({
       name: undefined,
       attowner: undefined,
@@ -57,6 +57,7 @@ export default class ColumnSchema extends BaseUISchema {
     this.nodeInfo = nodeInfo;
     this.cltypeOptions = cltypeOptions;
     this.collspcnameOptions = collspcnameOptions;
+    this.inErd = inErd;
 
     this.datatypes = [];
   }
@@ -71,8 +72,7 @@ export default class ColumnSchema extends BaseUISchema {
       return true;
     }
 
-    if('schema' in this.nodeInfo)
-    {
+    if(this.nodeInfo &&  ('schema' in this.nodeInfo)) {
       // We will disable control if it's system columns
       // inheritedfrom check is useful when we use this schema in table node
       // inheritedfrom has value then we should disable it
@@ -86,7 +86,7 @@ export default class ColumnSchema extends BaseUISchema {
       // ie: it's position is less than 1
       return !(!_.isUndefined(state.attnum) && state.attnum > 0);
     }
-    return true;
+    return false;
   }
 
   editableCheckForTable(state) {
@@ -179,7 +179,7 @@ export default class ColumnSchema extends BaseUISchema {
           ) || (
             'is_partitioned' in obj.top.origData
             && obj.top.origData['is_partitioned']
-            && obj.nodeInfo.server && obj.nodeInfo.server.version < 11000
+            && obj.getServerVersion() < 11000
           ))
         ) {
           return true;
@@ -239,7 +239,7 @@ export default class ColumnSchema extends BaseUISchema {
             filter: (options)=>{
               let result = options;
               let edit_types = state?.edit_types || [];
-              if(!obj.isNew(state)) {
+              if(!obj.isNew(state) && !this.inErd) {
                 result = _.filter(options, (o)=>edit_types.indexOf(o.value) > -1);
               }
               return result;
@@ -256,7 +256,7 @@ export default class ColumnSchema extends BaseUISchema {
             filter: (options)=>{
               let result = options;
               let edit_types = row?.edit_types || [];
-              if(!obj.isNew(row)) {
+              if(!obj.isNew(row) && !this.inErd) {
                 result = _.filter(options, (o)=>edit_types.indexOf(o.value) > -1);
               }
               return result;
@@ -272,7 +272,10 @@ export default class ColumnSchema extends BaseUISchema {
       id: 'inheritedfrom', label: gettext('Inherited from table'),
       type: 'text', readonly: true, editable: false,
       visible: function() {
-        return _.isUndefined(this.nodeInfo['table'] || this.nodeInfo['view'] || this.nodeInfo['mview']);
+        if(this.nodeInfo) {
+          return _.isUndefined(this.nodeInfo['table'] || this.nodeInfo['view'] || this.nodeInfo['mview']);
+        }
+        return false;
       },
     },{
       id: 'attlen', label: gettext('Length/Precision'),
@@ -417,8 +420,7 @@ export default class ColumnSchema extends BaseUISchema {
           {'label': gettext('IDENTITY'), 'value': 'i'},
         ];
 
-        if (this.nodeInfo && this.nodeInfo.server &&
-            this.nodeInfo.server.version >= 120000) {
+        if (this.getServerVersion() >= 120000) {
           // You can't change the existing column to Generated column.
           if (this.isNew(state)) {
             options.push({
@@ -529,15 +531,18 @@ export default class ColumnSchema extends BaseUISchema {
       ], null, null, ['name', 'value']),
       uniqueCol : ['name'], mode: ['edit', 'create'],
       canAdd: true, canEdit: false, canDelete: true,
-    }, {
+    },{
+      id: 'security', label: gettext('Security'), type: 'group',
+      visible: !this.inErd,
+    },{
       id: 'attacl', label: gettext('Privileges'), type: 'collection',
-      group: gettext('Security'),
+      group: 'security',
       schema: this.getPrivilegeRoleSchema(['a','r','w','x']),
       mode: ['edit'], canAdd: true, canDelete: true,
       uniqueCol : ['grantee'],
     },{
       id: 'seclabels', label: gettext('Security labels'), canAdd: true,
-      schema: new SecLabelSchema(), group: gettext('Security'),
+      schema: new SecLabelSchema(), group: 'security',
       mode: ['edit', 'create'], editable: false, type: 'collection',
       min_version: 90100, canEdit: false, canDelete: true,
       uniqueCol : ['provider'],
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.ui.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.ui.js
index 5903f5394..2dffa5f02 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.ui.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/static/js/foreign_key.ui.js
@@ -86,7 +86,7 @@ class ForeignKeyHeaderSchema extends BaseUISchema {
   }
 }
 
-class ForeignKeyColumnSchema extends BaseUISchema {
+export class ForeignKeyColumnSchema extends BaseUISchema {
   constructor() {
     super({
       local_column: undefined,
@@ -111,7 +111,7 @@ class ForeignKeyColumnSchema extends BaseUISchema {
 }
 
 export default class ForeignKeySchema extends BaseUISchema {
-  constructor(fieldOptions={}, nodeInfo, getColumns, initData={}) {
+  constructor(fieldOptions={}, nodeInfo, getColumns, initValues={}, inErd=false) {
     super({
       name: undefined,
       reftab: undefined,
@@ -128,7 +128,7 @@ export default class ForeignKeySchema extends BaseUISchema {
       autoindex: true,
       coveringindex: undefined,
       hasindex:undefined,
-      ...initData,
+      ...initValues,
     });
 
     this.nodeInfo = nodeInfo;
@@ -136,7 +136,7 @@ export default class ForeignKeySchema extends BaseUISchema {
     this.fkHeaderSchema = new ForeignKeyHeaderSchema(fieldOptions, getColumns);
     this.fkHeaderSchema.fkObj = this;
     this.fkColumnSchema = new ForeignKeyColumnSchema();
-
+    this.inErd = inErd;
   }
 
   get idAttribute() {
@@ -240,9 +240,7 @@ export default class ForeignKeySchema extends BaseUISchema {
           return true;
         }
         // If we are in table edit mode then
-        if(obj.inTable) {
-          return true;
-        } else if(state.hasindex) {
+        if(state.hasindex) {
           return true;
         }
         return false;
@@ -252,7 +250,7 @@ export default class ForeignKeySchema extends BaseUISchema {
           return {};
         }
         // If we are in table edit mode
-        if(obj.inTable) {
+        if(obj.inTable && !this.inErd) {
           if(obj.isNew(state) && obj.top.isNew()) {
             return {autoindex: false, coveringindex: ''};
           }
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.ui.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.ui.js
index 94622e2b3..1290e6ce3 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.ui.js
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/static/js/table.ui.js
@@ -70,7 +70,7 @@ export function getNodeTableSchema(treeNodeInfo, itemNodeData, pgBrowser) {
 }
 
 export class ConstraintsSchema extends BaseUISchema {
-  constructor(nodeInfo, getFkObj, getExConsObj, otherOptions) {
+  constructor(nodeInfo, getFkObj, getExConsObj, otherOptions, inErd=false) {
     super();
     this.nodeInfo = nodeInfo;
     this.primaryKeyObj = new PrimaryKeySchema({
@@ -81,13 +81,16 @@ export class ConstraintsSchema extends BaseUISchema {
       spcname: otherOptions.spcname,
     }, nodeInfo);
     this.exConsObj = getExConsObj();
+    this.inErd = inErd;
   }
 
   changeColumnOptions(colOptions) {
     this.primaryKeyObj.changeColumnOptions(colOptions);
     this.fkObj.changeColumnOptions(colOptions);
-    this.uniqueConsObj.changeColumnOptions(colOptions);
-    this.exConsObj.changeColumnOptions(colOptions);
+    if(!this.inErd) {
+      this.uniqueConsObj.changeColumnOptions(colOptions);
+      this.exConsObj.changeColumnOptions(colOptions);
+    }
   }
 
   anyColumnAdded(state) {
@@ -147,20 +150,24 @@ export class ConstraintsSchema extends BaseUISchema {
           return {foreign_key: []};
         }
       }
+    },{
+      id: 'check_group', type: 'group', label: gettext('Check'), visible: !this.inErd,
     },{
       id: 'check_constraint', label: '',
       schema: new CheckConstraintSchema(),
       editable: false, type: 'collection',
-      group: gettext('Check'), mode: ['edit', 'create'],
+      group: 'check_group', mode: ['edit', 'create'],
       canEdit: true, canDelete: true, deps:['is_partitioned'],
       canAdd: true,
       columns : ['name', 'consrc'],
       disabled: this.inCatalog,
+    },{
+      id: 'unique_group', type: 'group', label: gettext('Unique'), visible: !this.inErd,
     },{
       id: 'unique_constraint', label: '',
       schema: this.uniqueConsObj,
       editable: false, type: 'collection',
-      group: gettext('Unique'), mode: ['edit', 'create'],
+      group: 'unique_group', mode: ['edit', 'create'],
       canEdit: true, canDelete: true, deps:['is_partitioned', 'typname'],
       columns : ['name', 'columns'],
       disabled: this.inCatalog,
@@ -176,11 +183,13 @@ export class ConstraintsSchema extends BaseUISchema {
           return {unique_constraint: []};
         }
       }
+    },{
+      id: 'exclude_group', type: 'group', label: gettext('Exclude'), visible: !this.inErd,
     },{
       id: 'exclude_constraint', label: '',
       schema: this.exConsObj,
       editable: false, type: 'collection',
-      group: gettext('Exclude'), mode: ['edit', 'create'],
+      group: 'exclude_group', mode: ['edit', 'create'],
       canEdit: true, canDelete: true, deps:['is_partitioned'],
       columns : ['name', 'columns', 'constraint'],
       disabled: this.inCatalog,
@@ -276,7 +285,7 @@ export class LikeSchema extends BaseUISchema {
 
 export default class TableSchema extends BaseUISchema {
   constructor(fieldOptions={}, nodeInfo, schemas={}, getPrivilegeRoleSchema=()=>{}, getColumns=()=>[],
-    getCollations=()=>[], getOperatorClass=()=>[], getAttachTables=()=>[], initValues={}) {
+    getCollations=()=>[], getOperatorClass=()=>[], getAttachTables=()=>[], initValues={}, inErd=false) {
     super({
       name: undefined,
       oid: undefined,
@@ -307,6 +316,7 @@ export default class TableSchema extends BaseUISchema {
       autovacuum_enabled: 'x',
       primary_key: [],
       foreign_key: [],
+      partition_keys: [],
       partitions: [],
       partition_type: 'range',
       is_partitioned: false,
@@ -325,6 +335,24 @@ export default class TableSchema extends BaseUISchema {
     this.columnsSchema = this.schemas.columns && this.schemas.columns() || {};
     this.vacuumSettingsSchema = this.schemas.vacuum_settings && this.schemas.vacuum_settings() || {};
     this.partitionKeysObj = new PartitionKeysSchema([], getCollations, getOperatorClass);
+    this.inErd = inErd;
+  }
+
+  static getErdSupportedData(data) {
+    let newData = {...data};
+    const SUPPORTED_KEYS = [
+      'name', 'schema', 'description', 'rlspolicy', 'forcerlspolicy', 'fillfactor',
+      'toast_tuple_target', 'parallel_workers', 'relhasoids', 'relpersistence',
+      'columns', 'primary_key', 'foreign_key',
+    ];
+    newData = _.pick(newData, SUPPORTED_KEYS);
+
+    /* Remove inherited references */
+    newData.columns = newData.columns.map((c)=>{
+      delete c.inheritedfromtable;
+      return c;
+    });
+    return newData;
   }
 
   get idAttribute() {
@@ -397,9 +425,9 @@ export default class TableSchema extends BaseUISchema {
       id: 'oid', label: gettext('OID'), type: 'text', mode: ['properties'],
     },{
       id: 'relowner', label: gettext('Owner'), type: 'select',
-      options: this.fieldOptions.relowner, noEmpty: true,
+      options: this.fieldOptions.relowner, noEmpty: this.inErd ? false : true,
       mode: ['properties', 'create', 'edit'], controlProps: {allowClear: false},
-      readonly: this.inCatalog,
+      readonly: this.inCatalog, visible: !this.inErd,
     },{
       id: 'schema', label: gettext('Schema'), type: 'select',
       options: this.fieldOptions.schema, noEmpty: true,
@@ -407,7 +435,7 @@ export default class TableSchema extends BaseUISchema {
       readonly: this.inCatalog,
     },{
       id: 'spcname', label: gettext('Tablespace'),
-
+      visible: !this.inErd,
       mode: ['properties', 'create', 'edit'], deps: ['is_partitioned'],
       readonly: this.inCatalog, type: (state)=>{
         return {
@@ -421,6 +449,9 @@ export default class TableSchema extends BaseUISchema {
       id: 'partition', type: 'group', label: gettext('Partitions'),
       mode: ['edit', 'create'], min_version: 100000,
       visible: function(state) {
+        if(this.inErd) {
+          return false;
+        }
         // Always show in case of create mode
         if (obj.isNew(state) || state.is_partitioned)
           return true;
@@ -429,7 +460,7 @@ export default class TableSchema extends BaseUISchema {
     },{
       id: 'is_partitioned', label:gettext('Partitioned table?'), cell: 'switch',
       type: 'switch', mode: ['properties', 'create', 'edit'],
-      min_version: 100000,
+      min_version: 100000, visible: !this.inErd,
       readonly: function(state) {
         if (!obj.isNew(state))
           return true;
@@ -447,7 +478,7 @@ export default class TableSchema extends BaseUISchema {
       type: 'select', group: gettext('Columns'),
       deps: ['typname', 'is_partitioned'], mode: ['create', 'edit'],
       controlProps: { multiple: true, allowClear: false, placeholder: gettext('Select to inherit from...')},
-      options: this.fieldOptions.coll_inherits,
+      options: this.fieldOptions.coll_inherits, visible: !this.inErd,
       optionsLoaded: (res)=>obj.inheritedTableList=res,
       disabled: (state)=>{
         if(state.adding_inherit_cols || state.is_partitioned){
@@ -581,7 +612,18 @@ export default class TableSchema extends BaseUISchema {
       deps: ['typname', 'is_partitioned'],
       depChange: (state, source, topState, actionObj)=>{
         if(source[0] === 'columns') {
-          obj.changeColumnOptions(state.columns);
+          /* In ERD, attnum is an imp var for setting the links
+          Here, attnum is set to max avail value.
+          */
+          let columns = state.columns;
+          if(actionObj.type === SCHEMA_STATE_ACTIONS.ADD_ROW && this.inErd) {
+            let lastAttnum = _.maxBy(columns, (c)=>c.attnum)?.attnum;
+            if(_.isUndefined(lastAttnum) || _.isNull(lastAttnum)) {
+              lastAttnum = -1;
+            }
+            columns[columns.length-1].attnum = lastAttnum + 1;
+          }
+          obj.changeColumnOptions(columns);
           /* If primary key switch changes, primary key collection need to change */
           if(actionObj.path.indexOf('is_primary_key') > -1) {
             let tabColPath = _.slice(actionObj.path, 0, -1);
@@ -631,6 +673,7 @@ export default class TableSchema extends BaseUISchema {
     },{
       id: 'typname', label: gettext('Of type'), type: 'select',
       mode: ['properties', 'create', 'edit'], group: 'advanced', deps: ['coll_inherits'],
+      visible: !this.inErd,
       disabled: (state)=>{
         if(!obj.inSchemaWithModelCheck(state) && isEmptyString(state.coll_inherits)) {
           return false;
@@ -743,6 +786,7 @@ export default class TableSchema extends BaseUISchema {
       type: 'nested-fieldset', label: gettext('Like'),
       group: 'advanced', mode: ['create'],
       schema: new LikeSchema(this.fieldOptions.like_relation),
+      visible: !this.inErd,
     },{
       id: 'partition_type', label:gettext('Partition Type'),
       editable: false, type: 'select', controlProps: {allowClear: false},
@@ -774,6 +818,7 @@ export default class TableSchema extends BaseUISchema {
       id: 'partition_keys', label:gettext('Partition Keys'),
       schema: obj.partitionKeysObj,
       editable: true, type: 'collection',
+      columns: ['key_type', 'pt_column', 'expression'].concat(!this.inErd ? ['collationame', 'op_class'] : []),
       group: 'partition', mode: ['create'],
       deps: ['is_partitioned', 'partition_type', 'typname'],
       canEdit: false, canDelete: true,
@@ -885,28 +930,32 @@ export default class TableSchema extends BaseUISchema {
         '</li></ul>',
       ].join(''),
       min_version: 100000,
-    },
-    {
+    },{
+      type: 'group', id: 'parameters', label: gettext('Parameters'),
+      visible: !this.inErd,
+    },{
       // Here - we will create tab control for storage parameters
       // (auto vacuum).
-      type: 'nested-tab', group: gettext('Parameters'),
+      type: 'nested-tab', group: 'parameters',
       mode: ['edit', 'create'], deps: ['is_partitioned'],
-      schema: this.vacuumSettingsSchema,
+      schema: this.vacuumSettingsSchema, visible: !this.inErd,
+    },{
+      id: 'security_group', type: 'group', label: gettext('Security'), visible: !this.inErd,
     },
     {
       id: 'relacl_str', label: gettext('Privileges'), disabled: this.inCatalog,
-      type: 'text', mode: ['properties'], group: gettext('Security'),
+      type: 'text', mode: ['properties'], group: 'security_group',
     },
     {
       id: 'relacl', label: gettext('Privileges'), type: 'collection',
-      group: gettext('Security'), schema: this.getPrivilegeRoleSchema(['a','r','w','d','D','x','t']),
+      group: 'security_group', schema: this.getPrivilegeRoleSchema(['a','r','w','d','D','x','t']),
       mode: ['edit', 'create'], canAdd: true, canDelete: true,
       uniqueCol : ['grantee'],
     },{
       id: 'seclabels', label: gettext('Security labels'), canEdit: false,
       schema: new SecLabelSchema(), editable: false, canAdd: true,
       type: 'collection', min_version: 90100, mode: ['edit', 'create'],
-      group: gettext('Security'), canDelete: true, control: 'unique-col-collection',
+      group: 'security_group', canDelete: true, control: 'unique-col-collection',
     },{
       id: 'vacuum_settings_str', label: gettext('Storage settings'),
       type: 'multiline', group: 'advanced', mode: ['properties'],
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py
index e0099396e..9f370a951 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/utils.py
@@ -1125,7 +1125,7 @@ class BaseTableView(PGChildNodeView, BasePartitionTable, VacuumSettings):
         elif part_type in data and data[part_type] == 'hash':
             partition_scheme = 'HASH ('
 
-        for row in data[part_keys]:
+        for row in data.get(part_keys, []):
             if row['key_type'] == 'column':
                 partition_scheme += self.qtIdent(
                     self.conn, row['pt_column'])
@@ -1141,7 +1141,7 @@ class BaseTableView(PGChildNodeView, BasePartitionTable, VacuumSettings):
                 partition_scheme += row['expression'] + ', '
 
         # Remove extra space and comma
-        if len(data[part_keys]) > 0:
+        if len(data.get(part_keys, [])) > 0:
             partition_scheme = partition_scheme[:-2]
         partition_scheme += ')'
 
diff --git a/web/pgadmin/static/js/SchemaView/FormView.jsx b/web/pgadmin/static/js/SchemaView/FormView.jsx
index 17371202e..74fa2bb2a 100644
--- a/web/pgadmin/static/js/SchemaView/FormView.jsx
+++ b/web/pgadmin/static/js/SchemaView/FormView.jsx
@@ -205,6 +205,13 @@ export default function FormView({
 
     if(modeSupported) {
       let {group, CustomControl} = field;
+      if(field.type === 'group') {
+        groupLabels[field.id] = field.label;
+        if(!visible) {
+          schemaRef.current.filterGroups.push(field.label);
+        }
+        return;
+      }
       group = groupLabels[group] || group || defaultTab;
 
       if(!tabs[group]) tabs[group] = [];
@@ -261,11 +268,6 @@ export default function FormView({
         } else {
           tabs[group].push(<DataGridView {...props}/>);
         }
-      } else if(field.type === 'group') {
-        groupLabels[field.id] = field.label;
-        if(!visible) {
-          schemaRef.current.filterGroups.push(field.label);
-        }
       } else {
         /* Its a form control */
         const hasError = _.isEqual(accessPath.concat(field.id), stateUtils.formErr.name);
diff --git a/web/pgadmin/static/js/SchemaView/index.jsx b/web/pgadmin/static/js/SchemaView/index.jsx
index 0f3073e9e..d78ba7a7b 100644
--- a/web/pgadmin/static/js/SchemaView/index.jsx
+++ b/web/pgadmin/static/js/SchemaView/index.jsx
@@ -89,7 +89,8 @@ function isValueEqual(val1, val2) {
   /* If the orig value and new value are of different datatype but of same value(numeric) "no change" */
   /* If the orig value is undefined or null and new value is boolean false "no change" */
   if ((_.isEqual(val1, val2)
-    || ((val1 === null || _.isUndefined(val1)) && !val2)
+    || ((val1 === null || _.isUndefined(val1)) && val2 === '')
+    || ((val1 === null || _.isUndefined(val1)) && typeof(val2) === 'boolean' && !val2)
     || (attrDefined ? _.isEqual(val1.toString(), val2.toString()) : false
     ))) {
     return true;
@@ -98,22 +99,6 @@ function isValueEqual(val1, val2) {
   }
 }
 
-function objectComparator(obj1, obj2) {
-  for(const key of _.union(Object.keys(obj1), Object.keys(obj2))) {
-    let equal = isValueEqual(obj1[key], obj2[key]);
-    if(equal) {
-      continue;
-    } else {
-      return false;
-    }
-  }
-  return true;
-}
-
-const diffArrayOptions = {
-  compareFunction: objectComparator,
-};
-
 function getChangedData(topSchema, viewHelperProps, sessData, stringify=false, includeSkipChange=true) {
   let changedData = {};
   let isEdit = viewHelperProps.mode === 'edit';
@@ -173,13 +158,13 @@ function getChangedData(topSchema, viewHelperProps, sessData, stringify=false, i
             );
             change = {};
             if(changeDiff.added.length > 0) {
-              change['added'] = cleanCid(changeDiff.added);
+              change['added'] = cleanCid(changeDiff.added, viewHelperProps.keepCid);
             }
             if(changeDiff.removed.length > 0) {
               change['deleted'] = cleanCid(changeDiff.removed.map((row)=>{
                 /* Deleted records should be original, not the changed */
                 return _.find(_.get(origVal, field.id), ['cid', row.cid]);
-              }));
+              }), viewHelperProps.keepCid);
             }
             if(changeDiff.updated.length > 0) {
               /* There is change in collection. Parse further to go deep */
@@ -204,7 +189,7 @@ function getChangedData(topSchema, viewHelperProps, sessData, stringify=false, i
                   });
                 }
               }
-              change['changed'] = cleanCid(change['changed']);
+              change['changed'] = cleanCid(change['changed'], viewHelperProps.keepCid);
             }
             if(Object.keys(change).length > 0) {
               attrChanged(field.id, change, true);
@@ -214,21 +199,18 @@ function getChangedData(topSchema, viewHelperProps, sessData, stringify=false, i
           }
         } else if(!isEdit) {
           if(field.type === 'collection') {
-            /* For fixed rows, check the updated changes */
-            if(!_.isUndefined(field.fixedRows)) {
-              const changeDiff = diffArray(
-                _.get(origVal, field.id) || [],
-                _.get(sessVal, field.id) || [],
-                'cid',
-                diffArrayOptions
-              );
-              if(changeDiff.updated.length > 0) {
-                let change = cleanCid(_.get(sessVal, field.id));
-                attrChanged(field.id, change, true);
-              }
-            } else {
-              let change = cleanCid(_.get(sessVal, field.id));
-              attrChanged(field.id, change);
+            const changeDiff = diffArray(
+              _.get(origVal, field.id) || [],
+              _.get(sessVal, field.id) || [],
+              'cid',
+            );
+            /* For fixed rows, check only the updated changes */
+            if((!_.isUndefined(field.fixedRows) && changeDiff.updated.length > 0)
+              || (_.isUndefined(field.fixedRows) && (
+                changeDiff.added.length > 0 || changeDiff.removed.length > 0 || changeDiff.updated.length > 0
+              ))) {
+              let change = cleanCid(_.get(sessVal, field.id), viewHelperProps.keepCid);
+              attrChanged(field.id, change, true);
             }
           } else {
             attrChanged(field.id);
@@ -409,18 +391,18 @@ const sessDataReducer = (state, action)=>{
 };
 
 /* Remove cid key added by prepareData */
-function cleanCid(coll) {
-  if(!coll) {
+function cleanCid(coll, keepCid=false) {
+  if(!coll || keepCid) {
     return coll;
   }
   return coll.map((o)=>_.pickBy(o, (v, k)=>k!='cid'));
 }
 
-function prepareData(val) {
+function prepareData(val, createMode=false) {
   if(_.isPlainObject(val)) {
     _.forIn(val, function (el) {
       if (_.isObject(el)) {
-        prepareData(el);
+        prepareData(el, createMode);
       }
     });
   } else if(_.isArray(val)) {
@@ -432,8 +414,8 @@ function prepareData(val) {
         So to decide whether row is new or not set, the cid starts with
         nn (not new) for existing rows. Newly added will start with 'c' (created)
         */
-        el['cid'] = _.uniqueId('nn');
-        prepareData(el);
+        el['cid'] = createMode ? _.uniqueId('c') : _.uniqueId('nn');
+        prepareData(el, createMode);
       }
     });
   }
@@ -532,7 +514,7 @@ function SchemaDialogView({
       });
     } else {
       /* Use the defaults as the initital data */
-      schema.origData = prepareData(schema.defaults);
+      schema.origData = prepareData(schema.defaults, true);
       schema.initialise(schema.origData);
       sessDispatch({
         type: SCHEMA_STATE_ACTIONS.INIT,
@@ -624,6 +606,7 @@ function SchemaDialogView({
           );
         }
       }).catch((err)=>{
+        console.error(err);
         setFormErr({
           name: 'apierror',
           message: parseApiError(err),
diff --git a/web/pgadmin/static/js/Theme/index.jsx b/web/pgadmin/static/js/Theme/index.jsx
index b27692875..3a0118802 100644
--- a/web/pgadmin/static/js/Theme/index.jsx
+++ b/web/pgadmin/static/js/Theme/index.jsx
@@ -106,23 +106,6 @@ basicSettings = createMuiTheme(basicSettings, {
         paddingRight: basicSettings.spacing(1.5),
       }
     },
-    MuiToggleButton: {
-      root: {
-        textTransform: 'none,',
-        padding: basicSettings.spacing(0.5, 2.5, 0.5, 0.5),
-        color: 'abc',
-        '&:hover':{
-          backgroundColor: 'abc',
-        },
-        '&$selected': {
-          color: 'abc',
-          backgroundColor: 'abc',
-          '&:hover':{
-            backgroundColor: 'abc',
-          }
-        }
-      }
-    },
     MuiAccordion: {
       root: {
         boxShadow: 'none',
@@ -172,6 +155,17 @@ basicSettings = createMuiTheme(basicSettings, {
       body1: {
         fontSize: '1em',
       }
+    },
+    MuiDialog: {
+      paper: {
+        margin: 0,
+      }
+    },
+    MuiTooltip: {
+      popper: {
+        top: 0,
+        zIndex: 9999,
+      }
     }
   },
   transitions: {
@@ -374,6 +368,7 @@ function getFinalTheme(baseTheme) {
       },
       MuiToggleButton: {
         root: {
+          padding: 'abc',
           paddingRight: baseTheme.spacing(2.5),
           paddingLeft: baseTheme.spacing(0.5),
           color: 'abc',
diff --git a/web/pgadmin/tools/erd/__init__.py b/web/pgadmin/tools/erd/__init__.py
index 6d16cbd79..6978d5db1 100644
--- a/web/pgadmin/tools/erd/__init__.py
+++ b/web/pgadmin/tools/erd/__init__.py
@@ -532,6 +532,35 @@ def prequisite(trans_id, sgid, sid, did):
     )
 
 
+def translate_foreign_keys(tab_fks, tab_data, all_nodes):
+    """
+    This function will take the from table foreign keys and translate
+    it into non oid based format. It will allow creating FK sql even
+    if table is not already created.
+    :param tab_fks: Table foreign keyss
+    :param tab_data: Table data
+    :param all_nodes: All the nodes info from ERD
+    :return: Translated foreign key data
+    """
+    for tab_fk in tab_fks:
+        if 'columns' not in tab_fk:
+            continue
+        print(tab_data)
+        remote_table = all_nodes[tab_fk['columns'][0]['references']]
+        tab_fk['schema'] = tab_data['schema']
+        tab_fk['table'] = tab_data['name']
+        tab_fk['remote_schema'] = remote_table['schema']
+        tab_fk['remote_table'] = remote_table['name']
+
+        new_column = {
+            'local_column': tab_fk['columns'][0]['local_column'],
+            'referenced': tab_fk['columns'][0]['referenced']
+        }
+        tab_fk['columns'][0] = new_column
+
+    return tab_fks
+
+
 @blueprint.route('/sql/<int:trans_id>/<int:sgid>/<int:sid>/<int:did>',
                  methods=["POST"],
                  endpoint='sql')
@@ -542,12 +571,16 @@ def sql(trans_id, sgid, sid, did):
     conn = _get_connection(sid, did, trans_id)
 
     sql = ''
-    for tab_key, tab_data in data.get('nodes', {}).items():
+    tab_foreign_keys = []
+    all_nodes = data.get('nodes', {})
+    for tab_key, tab_data in all_nodes.items():
+        tab_fks = tab_data.pop('foreign_key', [])
+        tab_foreign_keys.extend(translate_foreign_keys(tab_fks, tab_data, all_nodes))
         sql += '\n\n' + helper.get_table_sql(tab_data)
 
-    for link_key, link_data in data.get('links', {}).items():
-        link_sql, name = fkey_utils.get_sql(conn, link_data, None)
-        sql += '\n\n' + link_sql
+    for tab_fk in tab_foreign_keys:
+        fk_sql, name = fkey_utils.get_sql(conn, tab_fk, None)
+        sql += '\n\n' + fk_sql
 
     return make_json_response(
         data=sql,
